from bloonix.heaven import H
from bloonix.exception import BloonixTooMuchObjects

class Controller:
    def startup(self):
        base_path = "/config/templates/:id/services"
        H.route(base_path, "list")
        H.route("%s/create/:command" % base_path, "create")
        H.route("%s/:service_parameter_id" % base_path, "show")
        H.route("%s/:service_parameter_id/update" % base_path, "update")
        H.route("%s/:service_parameter_id/delete" % base_path, "delete")
        H.route("%s/:service_parameter_id/options" % base_path, "options")
        H.route("%s/options/:command" % base_path, "options")

    def auto(self, opts):
        return H.plugin.service.auto(opts)

    def show(self, opts):
        return H.plugin.service.show(opts)

    def list(self, opts):
        ret = H.model.db.service_parameter.query(
            query=H.req.get_query_data(),
            count="id",
            table=[
                "service_parameter", [
                    "id",
                    "service_name",
                    "command",
                    "remote_check",
                    "interval",
                    "retry_interval",
                    "attempt_max",
                    "host_alive_check",
                ]
            ],
            condition=["where", ["service_parameter.template_id", opts["id"]]],
            order=["asc", "id"]
        )
        if ret.success == False:
            return H.plugin.error.set("err-606")
        H.stash.data = ret.data
        H.stash.total = ret.total

    def options(self, opts):
        H.plugin.service.options(opts)

    def create(self, opts):
        try:
            H.plugin.service.create(opts)
        except BloonixTooMuchObjects:
            return H.plugin.error.set("err-800")

    def update(self, opts):
        H.plugin.service.update(opts)

    def delete(self, opts):
        H.plugin.service.delete(opts)
