import re
from bloonix.heaven import H
from bloonix import utils

class Controller:
    def startup(self):
        H.route("/hosts/:id/services/:service_id/search", "search")
        H.route("/hosts/:id/services/:service_id/data", "data")

    def search(self, opts):
        service = H.model.db.service.get(opts["service_id"])
        date = H.req.param("date")

        if not date or not re.search(r"\d\d\d\d-\d\d-\d\d", date):
            date = utils.timestamp(dateonly=True)

        try:
            from_time = utils.unixtime("%s 00:00:00" % date)
            to_time = utils.unixtime("%s 23:59:59" % date)
        except Exception:
            return H.plugin.error.set("err-610", failed=["date"])

        ret = H.stash.data = H.model.ds.result.search(
            service_id=opts["service_id"],
            from_time=from_time,
            to_time=to_time)

        if ret.success == False:
            return H.plugin.error.set("err-606")

        H.stash.data = ret.data
        H.stash.total = ret.total

    def data(self, opts):
        timestamp = H.req.param("time")
        if not isinstance(timestamp, int):
            if re.search(r"^\d+\Z", timestamp):
                timestamp = int(timestamp)
            else:
                return H.plugin.error.set("err-610", failed=["time"])
        H.stash.data = H.model.ds.result.data(
            service_id=opts["service_id"],
            timestamp=timestamp)
