from bloonix.heaven import H

class Controller:
    def startup(self):
        self.db = H.model.db.service
        H.route("/services", "list")
        H.route("/services/status", "status")
        H.route("/services/summary", "summary")

    def status(self, opts):
        status = H.stash.data["status"] = {
            0:0, 1:0, 2:0, 3:0,
            4:0, 5:0, 6:0}
        for row in H.model.db.service.status():
            status[row["status"]] = row["count"]

    def summary(self, opts):
        ret = self.db.short(H.req.get_query_data())
        data = []
        index = {}

        for row in ret.data:
            if row["host_id"] not in index:
                index[row["host_id"]] = len(data)
                data.append({
                    "host_id": row["host_id"],
                    "hostname": row["hostname"],
                    "ipaddr1": row["ipaddr1"],
                    "project_class": row["project_class"],
                    "location_class": row["location_class"],
                    "highest_status": 0,
                    "by_status": [None,None,None,None,None,None,None],
                })
            i = index[row["host_id"]]
            d = data[i]
            if row["status"] > d["highest_status"]:
                d["highest_status"] = row["status"]
            if d["by_status"][row["status"]] is None:
                d["by_status"][row["status"]] = []
            d["by_status"][row["status"]].append({
                "service_id": row["id"],
                "service_name": row["service_name"],
                "status": row["status"],
                "message": row["message"],
                "acknowledged": row["acknowledged"]})

        H.stash.data = data

    def list(self, opts):
        ret = self.db.list(H.req.get_query_data())

        if ret.success == False:
            return H.plugin.error.set("err-606")

        H.stash.data = ret.data
        H.stash.total = ret.total
